/**
* Copyright 2007 - 2011 Skyway Software, Inc.
*/

package org.skyway.spring.util.dao.call.oracle;

import java.sql.Connection;

@SuppressWarnings("nls")
public class OracleArrayDescriptor extends OracleIntrospector{
	private Object arrayDescriptor;
	
	public OracleArrayDescriptor(String arrayName, Connection connection){
		this.arrayDescriptor = createDescriptor(arrayName, connection);
	}
	
	@Override
	public String getClassName() {
		return "oracle.sql.ArrayDescriptor";
	}

	@Override
	public Object getInstance() {
		return arrayDescriptor;
	}
	
	private Object createDescriptor(String arrayName, Connection connection){
		return findAndExecuteMethod("createDescriptor", arrayName, connection);
	}
	
	public String getBaseName(){
		return (String)findAndExecuteMethod("getBaseName");
	}
}
