/**
* Copyright 2007 - 2011 Skyway Software, Inc.
*/

package org.skyway.spring.util.dao.call.oracle;

import org.skyway.common.util.ConversionUtils;
import org.skyway.spring.util.dao.query.SQLResultsProvider;

public class OracleSQLResultsProvider extends SQLResultsProvider {
	private static final long serialVersionUID = 1L;

	/**
	 * When we get a result set back from an oracle stored procedure call
	 * we get a oracle.sql.TIMESTAMP result instead of a java.sql.Timestamp.
	 * We just ask the oracle instance for an instance of the jdbc type.
	 */
	@Override
	protected <T> T convertValue(Object sourceValue, Class<T> targetType){
		if (getTIMESTAMPClass().isInstance(sourceValue)){
			sourceValue = new OracleTIMESTAMP(sourceValue).timestampValue();
		}
		
		T convertedValue = (T) ConversionUtils.convert(sourceValue, targetType);
		
		return convertedValue;
	}
	
	protected Class<?> getTIMESTAMPClass(){
		return OracleIntrospector.findClassForName(OracleTIMESTAMP.getTIMESTAMPClassName());
	}
}
