/**
* Copyright 2007 - 2011 Skyway Software, Inc.
*/

package org.skyway.spring.util.dao.call.oracle;

import java.sql.Connection;
import java.sql.ResultSetMetaData;

@SuppressWarnings("nls")
public class OracleStructDescriptor extends OracleIntrospector{
	private Object structDescriptor;
	
	public OracleStructDescriptor(String structName, Connection connection){
		this.structDescriptor = createDescriptor(structName, connection);
	}
	
	@Override
	public String getClassName() {
		return "oracle.sql.StructDescriptor";
	}

	@Override
	public Object getInstance() {
		return structDescriptor;
	}
	
	private Object createDescriptor(String arrayName, Connection connection){
		return findAndExecuteMethod("createDescriptor", arrayName, connection);
	}
	
	public ResultSetMetaData getMetaData(){
		return (ResultSetMetaData)findAndExecuteMethod("getMetaData");
	}

	public int getLength(){
		return (Integer)findAndExecuteMethod("getLength");
	}
}
