package org.skyway.spring.util.jsf;

import java.util.Date;
import java.util.Locale;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;

import org.skyway.spring.util.databinding.DateConverter;
import org.skyway.spring.util.databinding.TypeConversionUtils;

/**
 * Base class for a converter that handles java.util.Date fields.
 * Subclasses provide the pattern and optionally the locale.
 * 
 * @author jperkins
 *
 */
public class ConverterForDate implements Converter{
	private DateConverter converter;
	
	public ConverterForDate(String pattern){
		this(pattern, TypeConversionUtils.getLocale());
	}
	
	public ConverterForDate(String pattern, Locale locale){
		this.converter = new DateConverter(pattern, locale);
	}
	
	protected DateConverter getDateConverter(){
		return converter;
	}

	public Object getAsObject(FacesContext context, UIComponent component, String value) {
		return converter.getDateFromText(value);
	}

	public String getAsString(FacesContext context, UIComponent component, Object value) {
		return converter.getTextFromDate((Date)value);
	}
}
