/**
* Copyright 2007 - 2011 Skyway Software, Inc.
*/
package org.skyway.spring.util.webservice;

import org.apache.commons.lang.StringUtils;

/**
 * Represents credential information that will be applied to outgoing web service calls.
 * 
 * @author jperkins
 *
 */
public class WebServiceInvocationCredentials {
	public static final String AUTHENTICATION_TYPE_WS_SECURITY = "ws-security";
	public static final String AUTHENTICATION_TYPE_BASIC = "basic";
	
	private String authenticationType;
	private String userId;
	private String password;
	private boolean hashPassword;
	
	public WebServiceInvocationCredentials(String authenticationType, String userId, String password, boolean hashPassword){
		this.authenticationType = authenticationType;
		this.userId = userId;
		this.password = password;
		this.hashPassword = hashPassword;
	}

	public String getAuthenticationType() {
		return authenticationType;
	}

	public String getUserId() {
		return userId;
	}

	public String getPassword() {
		return password;
	}

	public boolean isHashPassword() {
		return hashPassword;
	}
	
	public boolean isAuthenticationBasic(){
		return StringUtils.equalsIgnoreCase(getAuthenticationType(), AUTHENTICATION_TYPE_BASIC);
	}
	
	public boolean isAuthenticationWsSecurity(){
		return StringUtils.equalsIgnoreCase(getAuthenticationType(), AUTHENTICATION_TYPE_WS_SECURITY);
	}
}
