/**
* Copyright 2007 - 2011 Skyway Software, Inc.
*/package org.skyway.spring.util.webservice.cxf;


/**
 * Extends the SpringSecurityCallbackHandler to provide the spring security
 * 3.x specific class names.
 * 
 * @author jperkins
 *
 */
public class SpringSecurity3xCallbackHandler extends SpringSecurityCallbackHandler {
	@Override
	protected String getAuthenticationClassName() {
		return "org.springframework.security.authentication.UsernamePasswordAuthenticationToken";
	}

	protected String getAuthenticationInterfaceName(){
		return "org.springframework.security.core.Authentication";
	}
	
	@Override
	protected String getAuthenticationExceptionClassName() {
		return "org.springframework.security.core.AuthenticationException";
	}

	@Override
	protected String getAuthenticationManagerClassName() {
		return "org.springframework.security.authentication.AuthenticationManager";
	}

	@Override
	protected String getSecurityContextClassName() {
		return "org.springframework.security.core.context.SecurityContextImpl";
	}

	@Override
	protected String getSecurityContextInterfaceName() {
		return "org.springframework.security.core.context.SecurityContext";
	}

	@Override
	protected String getSecurityContextHolderClassName() {
		return "org.springframework.security.core.context.SecurityContextHolder";
	}
}
